<template>
  <app-header />
  <div class="feed">
    <section v-if="events">
      <h3>События в {{ getUserCity }}</h3>
      <div class="feed-list">
        <event-preview :event="event" v-for="event in events" :key="event.id" />
      </div>
    </section>
    <section v-if="organisations">
      <h3>Лучшие организации</h3>
      <div class="feed-list">
        <organisation-preview
          :organisation="organisation"
          v-for="organisation in organisations"
          :key="organisation.id"
        />
      </div>
    </section>
    <section v-if="members">
      <h3>Лучшие волонтеры {{ getUserCity }}</h3>
      <div class="feed-list">
        <volunteer-preview
          :volunteer="volunteer"
          v-for="volunteer in members"
          :key="volunteer.id"
        />
      </div>
    </section>
  </div>
</template>

<script>
import EventPreview from "@/components/EventPreview";
import OrganisationPreview from "@/components/OrganisationPreview";
import VolunteerPreview from "@/components/VolunteerPreview";
import { mapActions, mapGetters } from "vuex";
import AppHeader from "@/components/AppHeader";
export default {
  name: "FeedView",
  components: {
    AppHeader,
    VolunteerPreview,
    OrganisationPreview,
    EventPreview,
  },
  data() {
    return {
      organisations: "",
      events: "",
      members: "",
    };
  },
  computed: {
    ...mapGetters({
      getUserCity: "user/getUserCity",
    }),
  },

  methods: {
    ...mapActions({
      loadOrganisationsRating: "organisations/loadOrganisationsRating",
      loadEvents: "events/loadEvents",
      loadUsersRating: "users/loadUsersRating",
    }),
  },

  mounted() {
    this.loadOrganisationsRating().then((response) => {
      this.organisations = response.data.data;
    });
    this.loadEvents().then((response) => {
      this.events = response.data.data;
    });
    this.loadUsersRating().then((response) => {
      this.members = response.data.data;
    });
  },
};
</script>

<style scoped lang="scss">
.feed {
  max-width: 425px;
  margin: 0 auto;
  padding: 0 0 64px;
  > section {
    background: $white;
    padding: $base-space * 4;
    &:not(:last-child) {
      margin: 0 0 ($base-space * 2);
    }
    > h3 {
      font-style: normal;
      font-weight: 500;
      font-size: 18px;
      line-height: 18px;
      color: #5c5c5c;
      margin: 0 0 $base-space * 3;
    }
  }
  &-list {
    width: 100%;
    display: flex;
    overflow-x: auto;
    flex-flow: row;
    grid-gap: $base-space * 2;
    &::-webkit-scrollbar {
      display: none;
    }
  }
}
</style>
